----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:08:59 03/04/2010 
-- Design Name: 
-- Module Name:    top_level - Structural 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity fail_top is

    Port (
			padClk, padReset : IN  STD_LOGIC;
			padRC_switch		: IN STD_LOGIC;
			padRC_health 		: IN STD_LOGIC;
        		padRC_input, padAP_input   : IN  STD_LOGIC_VECTOR(6 downto 0);
			padOutput   		   : OUT STD_LOGIC_VECTOR(6 downto 0);
			



--			  clk : in std_logic;
--			  rst : in std_logic;
--			  RC_switch : in std_logic;
--			  AP_switch : in std_logic;
--			  RC_health : in std_logic;
--			  AP_health : in std_logic;
--			  RC_input : in  STD_LOGIC_VECTOR(6 downto 0);
--           		  AP_input : in  STD_LOGIC_VECTOR(6 downto 0);
--			  output : out  STD_LOGIC_VECTOR(6 downto 0);
	--		  output2 : out  STD_LOGIC_VECTOR(6 downto 0);
			  led: out std_logic_vector(1 downto 0)
--						  			  			  	  led2: out std_logic_vector(1 downto 0)
			  );
			  
end fail_top;

architecture Structural of fail_top is



component failsafe_unit is

	Generic (	AP_input_size: natural := 7;
					RC_input_size: natural := 7;
					output_size: natural := 7
				 );
    Port (
			  clk : in std_logic;
			  rst : in std_logic;
			  RC_switch : in std_logic;
--			  AP_switch : in std_logic;
			  RC_health : in std_logic;
--			  AP_health : in std_logic;
			  RC_input : in  STD_LOGIC_VECTOR(6 downto 0);
           AP_input : in  STD_LOGIC_VECTOR(6 downto 0);
			  output : out  STD_LOGIC_VECTOR(6 downto 0);
			  led: out std_logic_vector(1 downto 0)
			  );
end component;

component pass is
    Port ( input : in  STD_LOGIC;
           output : out  STD_LOGIC);
end component;

component PDO12CDG 
  port(A     : in  std_logic;
       PAD   : out std_logic);
end component;

component PDUDGZ 
  port(Y     : out  std_logic;
       PAD   : in   std_logic);
end component;


signal  clk :  std_logic;
signal	rst :  std_logic;
signal	RC_switch :  std_logic;
signal	RC_health :  std_logic;
signal  RC_input :   STD_LOGIC_VECTOR(6 downto 0);
signal  AP_input :   STD_LOGIC_VECTOR(6 downto 0);
signal	output :   STD_LOGIC_VECTOR(6 downto 0);

begin

-- Input RC_input pad mapping
  padAGen: for i in 6 downto 0 generate
    begin
        inpRC: PDUDGZ port map (Y => RC_input(i), PAD => padRC_input(i));
    
  end generate;

-- Input AP_input pad mapping
  padBGen: for i in 6 downto 0 generate
    begin
        inpAP: PDUDGZ port map (Y => AP_input(i), PAD => padAP_input(i));
    
  end generate;
  
-- Output output pad mapping
  padResultGen: for i in 6 downto 0 generate
    begin
        opRes: PDO12CDG port map (PAD => padOutput(i), A => output(i));
    
  end generate;

inpClk: 	PDUDGZ port map (PAD => padClk, Y => clk);
inpRst:		PDUDGZ port map (PAD => padReset, Y => rst);
inpRC_sw:	PDUDGZ port map (PAD => padRC_switch, Y => RC_switch);
inpRC_ht:	PDUDGZ port map (PAD => padRC_health, Y => RC_health);


c1:	failsafe_unit port map(clk=>clk, rst=>rst, RC_switch=>RC_switch, RC_health=>RC_health, RC_input=>RC_input, AP_input=>AP_input, output=>output, led=>led);


--sc2:	pass port map (RC_switch, output(0));

--output(0) <= clk;
--output(6 downto 1) <= "111111";
--led <= "11";
--led(0) <= RC_switch;
--led(1) <= '1';

end Structural;

